
# qMMC3 (quasi MMC3)

qMMC3はCPLD(ATF1502/ATF1504)を使用したMapper4(MMC3)互換のMMCです。  
qMMC3 is a Mapper4 (MMC3) compatible MMC using CPLD (ATF1502 / ATF1504).

## ディレクトリ構成/Directories

|ディレクトリ/Directory|内容/Contents|
|---|---|
|cupl|ファームウェアおよびソースコード<br>Firmware and source code.|
|eagle|プリント基板のCADデータとガーバーデータ<br>Printed circuit board CAD data and Gerber data.|

## ファームウェアの書き込み/Firmware writing

QMMC3A.jed は基板上側のCPLD用のファームウェアです。  
QMMC3B.jed は基板下側のCPLD用のファームウェアです。  
ATMISPを使用してファームウェアを書き込むには、[File][New]を選択し、
デバイス数に2を設定して、1つ目のデバイスにQMMC3A.jed、２つ目のデバイスにQMMC3B.jedを書き込みます。  
QMMC3A.jed is the firmware for CPLD on the upper side of the board.  
QMMC3B.jed is the firmware for CPLD on the lower side of the board.  
To write the firmware using ATMISP, select [File] [New], 
set the number of devices to 2, and set QMMC3A.jed to the first device and QMMC3B.jed to the second device. Write. 

