; [U^XN(Tu)

; pbg֌W

	; a : 0000nnnn ^Cg ZNg 
	; use reg : a x y
Pal_SetBGPalette:
	lda	Xcn,x
	ora	#$0f
	tax
	ldy	#15
.1:
	lda	Pal_Data_Frame,x
	sta	PAL_BGBUF,y
	dex
	dey
	bpl	.1
	rts

	; a : 0000nnnn ^Cg 
	; use reg : a x y
Pal_SetSPPalette:
	lda	Xcn,x
	ora	#$0f
	tax
	ldy	#15
.1:
	lda	Pal_Data_Object,x
	sta	PAL_BGBUF+16,y
	dex
	dey
	bpl	.1
	rts

; XvCg֌W

Spr_Init:
	ldx	#$00
.1:
	lda	#240
	sta	SPR_DATA,x
	lda	Int+4,x
	tax
	bne	.1

	lda	#1
	sta	<SPR_UPD
	rts


; Vcmd֌W

	; a : 0ddd0ttt d:darkness value 
	;     t:target (0:BG&SP 1:BG    2:SP       3:
	;               4:BG0   5:BG1-3 6:BG1-3&SP 7:)
	; use reg : a x y
	; use work : 0-1
Vcmd_SetPalette:
	and	#$77
	sta	<FNC_WORK
	and	#$07
	tax
	eor	<FNC_WORK
	sta	<FNC_WORK
	lda	.size,x
	sta	<FNC_WORK+1
	ldy	.offset,x
.1:
	lda	PAL_BGBUF,y
	sec
	sbc	<FNC_WORK
	bmi	.3
	cmp	#$0d
	bne	.4
.3:
	lda	#$1d
.4:
	sta	PAL_BGBUF2,y
	iny
	dec	<FNC_WORK+1
	bne	.1

	ldx	<VCMD_SIZE
	lda	#32
	sta	VCMD_DATA,x	; size
	lda	#$00
	sta	VCMD_DATA+1,x	; attr
	sta	VCMD_DATA+3,x	; ppu addr high
	lda	#$3f
	sta	VCMD_DATA+2,x	; ppu addr high
	lda	Int+36,x
	sta	<VCMD_SIZE
	tax

	ldy	#31
.5:
	dex
	lda	PAL_BGBUF2,y
	sta	VCMD_DATA,x
	dey
	bpl	.5

	rts

.offset:
	.db	 0,  0, 16,  0,  0,  4,  4,  0
.size:
	.db	32, 16, 16, 32,  4, 12, 28, 32

; [eBeB

	; x : ΏۃoN̈
	;     0 .. PPU $0000-$07ff
	;     1 .. PPU $0800-$0fff
	;     2 .. PPU $1000-$13ff
	;     3 .. PPU $1400-$17ff
	;     4 .. PPU $1800-$1bff
	;     5 .. PPU $1c00-$1fff
	; a : oNԍ
Util_SetSyncBank:
	sta	SYN_BANK+1,x
	lda	SYN_BANK
	ora	Bit,x
	sta	SYN_BANK
	rts

	; a : value (lo)
	; y : value (hi)
Util_SetLFSR:
	sta	<LFSR
	sty	<LFSR+1
	rts

	; a : result (lo)
	; y : result (hi)
Util_UpdateLFSR:
	lda	<LFSR
	bit	Int+$04
	beq	.1
	eor	#$01
.1:
	bit	Int+$08
	beq	.2
	eor	#$01
.2:
	bit	Int+$20
	beq	.3
	eor	#$01
.3:
	lsr	a
	ror	<LFSR+1
	ror	<LFSR

	lda	<LFSR
	ldy	<LFSR+1
	rts

